<?php
session_start();
require_once 'classes.php';

$clientId       = 'demo_oauth_client';
$clientSecret   = 'demo_oauth_secret';
$basicToken = base64_encode($clientId.":".$clientSecret);

$apiURL = "http://opencart3-oauth.api.opencart-api.com";

$OpenCartRestClient = new OpenCartRestApi($apiURL);

//1.STEP Get Bearer token
if(!isset($_SESSION['bearerToken'])){
    $OpenCartRestClient->printServiceTitle("1.STEP - Get Bearer token");
    $token = $OpenCartRestClient->customer->getToken($basicToken);
    $_SESSION['bearerToken'] = $token['data']["access_token"];
} else {
    $OpenCartRestClient->printServiceTitle("1.STEP - User already has bearerToken");
}

if(isset($_SESSION['bearerToken']) && !empty($_SESSION['bearerToken'])) {

    //2. STEP
    //Login
    $OpenCartRestClient->printServiceTitle("2.STEP - Login");
    $email = 'admin';
    $password = 'admin';
    $OpenCartRestClient->customer->login($email, $password);

//Get all products
    $OpenCartRestClient->printServiceTitle("Get all products (limit = 2, page=2)");
    $page = 2;
    $limit = 2;
    $OpenCartRestClient->product->getProducts($page, $limit);

//Get product by ID
    $OpenCartRestClient->printServiceTitle("Get product by ID");
    $productId = 40;
    $OpenCartRestClient->product->getProductById($productId);

//Delete product by ID
//$OpenCartRestClient->printServiceTitle("Delete product by ID");
//$productId = 40;
//$OpenCartRestClient->product->deleteProductById($productId);

//Update product quantity by ID
    $OpenCartRestClient->printServiceTitle("Update product quantity by ID");
    $quantity = rand(10, 999);
    $OpenCartRestClient->product->updateProductQuantity($productId, $quantity);

//Get product by ID after quantity update
    $OpenCartRestClient->printServiceTitle("Get product by ID after quantity update");
    $productId = 40;
    $OpenCartRestClient->product->getProductById($productId);

//Get categories
    $OpenCartRestClient->printServiceTitle("Get categories");
    $OpenCartRestClient->category->getCategories();

//Get category by ID
    $OpenCartRestClient->printServiceTitle("Get category by ID");
    $categoryId = 20;
    $OpenCartRestClient->category->getCategoryById($categoryId);

//Add new category
    $OpenCartRestClient->printServiceTitle("Add new category");
    $demoRandom = rand(1, 9999); //you do not need it, it is just for testing
    $category = array(
        'sort_order' => '1',
        'parent_id' => '1',
        'top' => '1',
        'column' => '1',
        'status' => '1',
        'category_store' => array(0),
        'category_description' => array(
            array(
                "language_id"=>1,
                "name"=>"Api demo category ".$demoRandom,
                "description"=>"desc",
                "meta_title"=>"meta_title_".$demoRandom,
                "meta_description"=>"meta_description_".$demoRandom,
                "meta_keyword"=>"meta_keyword_".$demoRandom
            )
        )
    );

    $OpenCartRestClient->category->addCategory($category);

//Delete category by ID
//$OpenCartRestClient->printServiceTitle("Delete categories by ID");
//$categoryIds = array("categories"=>array(69));
//$OpenCartRestClient->category->deleteCategoriesById($categoryIds);

//Get orders
    $OpenCartRestClient->printServiceTitle("Get orders");
    $orders = $OpenCartRestClient->order->getOrders();

    if (!empty($orders)) {
        if (!empty($orders['data'])) {
            //Get order by ID
            $OpenCartRestClient->printServiceTitle("Get order by ID");
            $orderId = $orders['data'][0]['order_id'];
            $OpenCartRestClient->order->getOrderById($orderId);

        }
    }


    //Add new product
    $OpenCartRestClient->printServiceTitle("Add new product");
    $demoRandom = rand(1, 9999); //you do not need it, it is just for testing

    $productObject = array (
        'model' => 'demo model '.$demoRandom,
        'quantity' => '300',
        'price' => '44.00',
        'tax_class_id' => '1',
        'manufacturer_id' => '20',
        'sku' => 'demo sku',
        'product_seo_url' => array (
            array (
                'keyword' => 'demo-keyword '.$demoRandom,
                'language_id' => '1',
                'store_id' => '0' )
        ),
        'status' => '1',
        'points' => 0,
        'reward' => 0,
        'image' => '',
        'other_images' => array (),
        'shipping' => '1',
        'stock_status_id' => 0,
        'upc' => '',
        'ean' => '',
        'jan' => '',
        'isbn' => '',
        'mpn' => '',
        'location' => '',
        'date_available' => '2017-05-12',
        'weight' => 0,
        'weight_class_id' => 0,
        'length' => 0,
        'width' => 0,
        'height' => 0,
        'length_class_id' => 0,
        'subtract' => 0,
        'minimum' => 0,
        'sort_order' => '',
        'product_store' => array ( 0 ),
        'product_related' => array ( '34' ),
        'product_filter' => array ( 34 ),
        'product_description' => array (
            array (
                'language_id' => '1',
                'name' => 'demo name '.$demoRandom,
                'description' => 'Description of the product '.$demoRandom,
                'meta_title' => 'Meta title of the product '.$demoRandom,
                'meta_description' => 'Meta description of the product '.$demoRandom,
                'meta_keyword' => 'demo, keyword, demo2 '.$demoRandom,
                'tag' => 'Product\'s tag, comma separeted') ),
        'product_category' => array ( 25 ),
        'product_special' => array (
            array (
                'customer_group_id' => '1',
                'price' => '200',
                'priority' => '1',
                'date_start' => '2015-02-23',
                'date_end' => '2019-02-23'
            )
        ),
        'product_discount' => array (
            array (
                'name' => 'demo name',
                'customer_group_id' => '1',
                'price' => '200',
                'priority' => '1',
                'quantity' => '1',
                'date_start' => '2015-02-23',
                'date_end' => '2019-02-23' ) ),
        'product_attribute' => array (
            array (
                'attribute_id' => '16',
                'product_attribute_description' => array (
                    array (
                        'text' => 'demo name '.$demoRandom,
                        'language_id' => '1' )
                )
            )
        ),
        'product_option' => array (
            array (
                'type' => 'radio',
                'option_id' => '11',
                'required' => '1',
                'product_option_value' => array (
                    array ( 'price' => '10.00',
                        'price_prefix' => '+',
                        'subtract' => '1',
                        'points' => '0',
                        'points_prefix' => '+',
                        'weight' => '0',
                        'weight_prefix' => '+',
                        'option_value_id' => '46',
                        'quantity' => '0')
                )
            )
        )
    );

    //$OpenCartRestClient->product->addProduct($productObject);


    //update product

    $productID = 59; //you will update this product

    $productUpdateObject = array (
        'model' => 'demo model '.$demoRandom,
        'quantity' => '100',
        'price' => '20.00',
        'tax_class_id' => '1',
        'manufacturer_id' => '20',
        'sku' => 'demo sku',
        'product_seo_url' => array (
            array (
                'keyword' => 'demo-keyword '.$demoRandom,
                'language_id' => '1',
                'store_id' => '0' )
        ),
        'status' => '1',
        'points' => 0,
        'reward' => 0,
        'image' => '',
        'other_images' => array (),
        'shipping' => '1',
        'stock_status_id' => 0,
        'upc' => '',
        'ean' => '',
        'jan' => '',
        'isbn' => '',
        'mpn' => '',
        'location' => '',
        'date_available' => '2017-05-12',
        'weight' => 0,
        'weight_class_id' => 0,
        'length' => 0,
        'width' => 0,
        'height' => 0,
        'length_class_id' => 0,
        'subtract' => 0,
        'minimum' => 0,
        'sort_order' => '',
        'product_store' => array ( 0 ),
        'product_related' => array ( '34' ),
        'product_filter' => array ( 34 ),
        'product_description' => array (
            array (
                'language_id' => '1',
                'name' => 'demo name updated '.$demoRandom,
                'description' => 'Description of the product updated '.$demoRandom,
                'meta_title' => 'Meta title of the product '.$demoRandom,
                'meta_description' => 'Meta description of the product '.$demoRandom,
                'meta_keyword' => 'demo, keyword, demo2 '.$demoRandom,
                'tag' => 'Product\'s tag, comma separeted') ),
        'product_category' => array ( 25 ),
        'product_special' => array (
            array (
                'customer_group_id' => '1',
                'price' => '200',
                'priority' => '1',
                'date_start' => '2019-02-23',
                'date_end' => '2019-05-23'
            )
        ),
        'product_discount' => array (
            array (
                'name' => 'demo name ww',
                'customer_group_id' => '1',
                'price' => '200',
                'priority' => '1',
                'quantity' => '1',
                'date_start' => '2015-02-23',
                'date_end' => '2019-02-23' ) ),
        'product_attribute' => array (
            array (
                'attribute_id' => '16',
                'product_attribute_description' => array (
                    array (
                        'text' => 'demo name 11 '.$demoRandom,
                        'language_id' => '1' )
                )
            )
        ),
        'product_option' => array (
            array (
                'type' => 'radio',
                'option_id' => '11',
                'required' => '1',
                'product_option_value' => array (
                    array ( 'price' => '10.00',
                        'price_prefix' => '+',
                        'subtract' => '1',
                        'points' => '0',
                        'points_prefix' => '+',
                        'weight' => '0',
                        'weight_prefix' => '+',
                        'option_value_id' => '46',
                        'quantity' => '0')
                )
            )
        )
    );

    //$OpenCartRestClient->product->updateProduct($productID, $productUpdateObject);
}


